// typography style

@use 'fun';

@mixin sans-serif-font() {
  font-family: ui-sans-serif, system-ui, -apple-system, "Segoe UI", "Ubuntu", Roboto, "Open Sans", Helvetica, Arial, sans-serif, "Apple Color Emoji", "Segoe UI Emoji", "Segoe UI Symbol", "Noto Color Emoji", emoji;
}

@mixin serif-font() {
  font-family: ui-serif, Cochin, Georgia, Cambria, "Times New Roman", Times, serif;
}

@mixin mono-font() {
  font-family: ui-monospace, SFMono-Regular, Menlo, Monaco, Consolas, "Liberation Mono", "Courier New", monospace;
}

@mixin inherit-font() {
  font: inherit;
}

@mixin font-size($value) {
  font-size: $value;
}

// https://developer.mozilla.org/en-US/docs/Web/CSS/font-weight#common_weight_name_mapping
@mixin font-weight($value) {
  font-weight: $value;
}

// normal <number> <length> <percentage>
@mixin line-height($value) {
  line-height: $value;
}

// auto loose normal strict anywhere
@mixin line-break($value) {
  line-break: $value;
}

// normal italic
@mixin font-style($value) {
  font-style: $value;
}

// normal [ <numeric-figure-values> || <numeric-spacing-values> || <numeric-fraction-values> || ordinal || slashed-zero ]
// numeric-figure-values: lining-nums oldstyle-nums
// numeric-spacing-values: proportional-nums tabular-nums
// numeric-fraction-values: diagonal-fractions stacked-fractions
@mixin font-variant-numeric($value) {
  font-variant-numeric: $value;
}

// left center right justify
@mixin text-align($value) {
  text-align: $value;
}

// underline line-through none
@mixin text-decoration($value) {
  text-decoration: $value;
}

// currentcolor transparent named-color hex-color
@mixin text-decoration-color($value: inherit) {
  text-decoration-color: $value;
}

// keyword: none underline overline line-through blink
// at least one keyword
@mixin text-decoration-line($value) {
  text-decoration-line: $value;
}

// solid double dotted dashed wavy
@mixin text-decoration-style($value) {
  text-decoration-style: $value;
}

// auto from-font or <length> or <percentage>
@mixin text-decoration-thickness($value) {
  text-decoration-thickness: $value;
}

// auto or <length> or <percentage>
@mixin text-underline-offset($value) {
  text-underline-offset: $value;
}

// auto under left right
@mixin text-underline-position($value) {
  text-underline-position: $value;
}

// uppercase lowercase capitalize none
@mixin text-transform($value) {
  text-transform: $value;
}

// ellipsis clip
@mixin text-overflow($value) {
  text-overflow: $value;
}

// inherit none
// offset-x offset-y [blur-radius] [color] [, offset-x offset-y [blur-radius] [color]]
@mixin text-shadow($value) {
  text-shadow: $value;
}

// see color
@mixin text-fill-color($value) {
  @include fun.prefix-only('text-fill-color', $value);
}

@mixin opacity($value) {
  opacity: $value;
}

// baseline top middle bottom text-top text-bottom sub super
@mixin vertical-align($value) {
  vertical-align: $value;
}

// normal nowrap pre pre-line pre-wrap
@mixin white-space($value) {
  white-space: $value;
}

// normal break-all
@mixin word-break($value) {
  word-break: $value;
}

// inherit currentColor
// transparent named-color hex-color
// rgb() rgba() hls() hlsa() hwb()
@mixin color($value: inherit) {
  color: $value;
}

// keyword: none
// type or image or position or keyword
// type [[image] position]
@mixin list-style($value) {
  list-style: $value;
}

// none or url()
@mixin list-style-image($value) {
  list-style-image: $value;
}

// inside outside
@mixin list-style-position($value) {
  list-style-position: $value;
}

// keyword: none disc circle square decimal georgian trad-chinese-informal kannada
// keyword or char
@mixin list-style-type($value) {
  list-style-type: $value;
}

@mixin list-style-none() {
  @include list-style(none inside);
}

// none manual auto
@mixin hyphens($value) {
  hyphens: $value;
}

// top bottom
// block-start block-end inline-start inline-end
@mixin caption-side($value) {
  caption-side: $value;
}

// normal or <length>
@mixin letter-spacing($value) {
  letter-spacing: $value;
}

// normal none url() linear-gradient()
// <string> or attr()
// Language- and position-dependent keywords
@mixin content($value) {
  content: $value;
}
